commit c60dd0eb28eff3deaa389b0aafa689d423fc12f1
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Mon Jun 17 22:02:46 2024 +0200

    diagnostics: Fix add_misspelling_candidates [PR115440]
    
    The option_map array for most entries contains just non-NULL opt0
        { "-Wno-", NULL, "-W", false, true },
        { "-fno-", NULL, "-f", false, true },
        { "-gno-", NULL, "-g", false, true },
        { "-mno-", NULL, "-m", false, true },
        { "--debug=", NULL, "-g", false, false },
        { "--machine-", NULL, "-m", true, false },
        { "--machine-no-", NULL, "-m", false, true },
        { "--machine=", NULL, "-m", false, false },
        { "--machine=no-", NULL, "-m", false, true },
        { "--machine", "", "-m", false, false },
        { "--machine", "no-", "-m", false, true },
        { "--optimize=", NULL, "-O", false, false },
        { "--std=", NULL, "-std=", false, false },
        { "--std", "", "-std=", false, false },
        { "--warn-", NULL, "-W", true, false },
        { "--warn-no-", NULL, "-W", false, true },
        { "--", NULL, "-f", true, false },
        { "--no-", NULL, "-f", false, true }
    and so add_misspelling_candidates works correctly for it, but 3 out of
    these,
        { "--machine", "", "-m", false, false },
        { "--machine", "no-", "-m", false, true },
    and
        { "--std", "", "-std=", false, false },
    use non-NULL opt1.  That says that
    --machine foo
    should map to
    -mfoo
    and
    --machine no-foo
    should map to
    -mno-foo
    and
    --std c++17
    should map to
    -std=c++17
    add_misspelling_canidates was not handling this, so it hapilly
    registered say
    --stdc++17
    or
    --machineavx512
    (twice) as spelling alternatives, when those options aren't recognized.
    Instead we support
    --std c++17
    or
    --machine avx512
    --machine no-avx512
    
    The following patch fixes that.  On this particular testcase, we no longer
    suggest anything, even when among the suggestion is say that
    --std c++17
    or
    -std=c++17
    etc.
    
    2024-06-17  Jakub Jelinek  <jakub@redhat.com>
    
            PR driver/115440
            * opts-common.cc (add_misspelling_candidates): If opt1 is non-NULL,
            add a space and opt1 to the alternative suggestion text.
    
            * g++.dg/cpp1z/pr115440.C: New test.
    
    (cherry picked from commit 96db57948b50f45235ae4af3b46db66cae7ea859)

diff --git a/gcc/opts-common.cc b/gcc/opts-common.cc
index 7c07d504696..99688009214 100644
--- a/gcc/opts-common.cc
+++ b/gcc/opts-common.cc
@@ -502,6 +502,7 @@ add_misspelling_candidates (auto_vec<char *> *candidates,
   for (unsigned i = 0; i < ARRAY_SIZE (option_map); i++)
     {
       const char *opt0 = option_map[i].opt0;
+      const char *opt1 = option_map[i].opt1;
       const char *new_prefix = option_map[i].new_prefix;
       size_t new_prefix_len = strlen (new_prefix);
 
@@ -510,8 +511,9 @@ add_misspelling_candidates (auto_vec<char *> *candidates,
 
       if (strncmp (opt_text, new_prefix, new_prefix_len) == 0)
 	{
-	  char *alternative = concat (opt0 + 1, opt_text + new_prefix_len,
-				      NULL);
+	  char *alternative
+	    = concat (opt0 + 1, opt1 ? " " : "", opt1 ? opt1 : "",
+		      opt_text + new_prefix_len, NULL);
 	  candidates->safe_push (alternative);
 	}
     }
diff --git a/gcc/testsuite/g++.dg/cpp1z/pr115440.C b/gcc/testsuite/g++.dg/cpp1z/pr115440.C
new file mode 100644
index 00000000000..788d4806fe2
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp1z/pr115440.C
@@ -0,0 +1,8 @@
+// PR driver/115440
+// { dg-do compile { target c++17_only } }
+// { dg-options "--c++17" }
+
+int i;
+
+// { dg-bogus "unrecognized command-line option '--c\\\+\\\+17'; did you mean '--stdc\\\+\\\+17'" "" { target *-*-* } 0 }
+// { dg-error "unrecognized command-line option '--c\\\+\\\+17'" "" { target *-*-* } 0 }

